Loading...
Searching...
No Matches
Halide::Internal::IRMatcher::BroadcastOp< A, B > Struct Template Reference

`#include <IRMatch.h>`

## Classes

struct | pattern_tag

## Public Member Functions

template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2, typename B2>
HALIDE_ALWAYS_INLINE bool | match (const BroadcastOp< A2, B2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
template<typename A1 = A>
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Public Attributes

A | a
B | lanes

## Static Public Attributes

static constexpr uint32_t | binds = bindings<A>::mask | bindings<B>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Broadcast
static constexpr IRNodeType | max_node_type = IRNodeType::Broadcast
static constexpr bool | canonical = A::canonical && B::canonical
static constexpr bool | foldable = false

## Detailed Description

template<typename A, typename B>
struct Halide::Internal::IRMatcher::BroadcastOp< A, B >

Definition at line 1736 of file IRMatch.h.

## Member Function Documentation

## match() [1/2]

template<typename A, typename B>
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1749 of file IRMatch.h.

References Halide::Internal::Broadcast::_node_type, a, Halide::Expr::get(), HALIDE_ALWAYS_INLINE, Halide::Internal::Broadcast::lanes, lanes, match(), and Halide::Internal::Broadcast::value.

Referenced by match(), and match().

## match() [2/2]

template<typename A, typename B>
template<uint32_t bound, typename A2, typename B2>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::match | ( | const BroadcastOp< A2, B2 > & | op,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1761 of file IRMatch.h.

References a, HALIDE_ALWAYS_INLINE, lanes, Halide::Internal::IRMatcher::bindings< T >::mask, match(), and Halide::Internal::IRMatcher::unwrap().

## make()

template<typename A, typename B>

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::BroadcastOp< A, B >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint ) const

inline

Definition at line 1767 of file IRMatch.h.

References a, halide_scalar_value_t::i64, lanes, halide_type_t::lanes, Halide::Internal::Broadcast::make(), and halide_scalar_value_t::u.

## make_folded_const()

template<typename A, typename B>
template<typename A1 = A>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::BroadcastOp< A, B >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state ) const

inline noexcept

Definition at line 1784 of file IRMatch.h.

References a, HALIDE_ALWAYS_INLINE, halide_scalar_value_t::i64, lanes, Halide::Internal::IRMatcher::MatcherState::special_values_mask, and halide_scalar_value_t::u.

## Member Data Documentation

## a

template<typename A, typename B>

A Halide::Internal::IRMatcher::BroadcastOp< A, B >::a

Definition at line 1738 of file IRMatch.h.

Referenced by make(), make_folded_const(), match(), match(), and Halide::Internal::IRMatcher::operator<<().

## lanes

template<typename A, typename B>

B Halide::Internal::IRMatcher::BroadcastOp< A, B >::lanes

Definition at line 1739 of file IRMatch.h.

Referenced by make(), make_folded_const(), match(), match(), and Halide::Internal::IRMatcher::operator<<().

## binds

template<typename A, typename B>

uint32_t Halide::Internal::IRMatcher::BroadcastOp< A, B >::binds = bindings<A>::mask | bindings<B>::mask

static constexpr

Definition at line 1741 of file IRMatch.h.

## min_node_type

template<typename A, typename B>

IRNodeType Halide::Internal::IRMatcher::BroadcastOp< A, B >::min_node_type = IRNodeType::Broadcast

static constexpr

Definition at line 1743 of file IRMatch.h.

## max_node_type

template<typename A, typename B>

IRNodeType Halide::Internal::IRMatcher::BroadcastOp< A, B >::max_node_type = IRNodeType::Broadcast

static constexpr

Definition at line 1744 of file IRMatch.h.

## canonical

template<typename A, typename B>

bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::canonical = A::canonical && B::canonical

static constexpr

Definition at line 1746 of file IRMatch.h.

## foldable

template<typename A, typename B>

bool Halide::Internal::IRMatcher::BroadcastOp< A, B >::foldable = false

static constexpr

Definition at line 1781 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h